Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.instruct
Class ForEachGroup

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.instruct.Instruction
              net.sf.saxon.instruct.ForEachGroup

All Implemented Interfaces:
  Serializable, SourceLocator, Container, ContextMappingFunction, EvaluableItem, SequenceIterable, TailCallReturner, SortKeyEvaluator, InstructionInfoProvider

    public class ForEachGroup

extends Instruction
implements ContextMappingFunction, SortKeyEvaluator

Handler for xsl:for-each-group elements in stylesheet. This is a new instruction defined in XSLT 2.0

See Also:
  Serialized Form

Field Summary
`static int` | `GROUP_ADJACENT`
`static int` | `GROUP_BY`
`static int` | `GROUP_ENDING`
`static int` | `GROUP_STARTING`

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`ForEachGroup(Expression select, Expression action, byte algorithm, Expression key, StringCollator collator, Expression collationNameExpression, String baseURI, SortKeyDefinition[] sortKeys)`

Method Summary
`void` | `checkPermittedContents(SchemaType parentType, StaticContext env, boolean whole)` Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
`int` | `computeDependencies()` Compute the dependencies of an expression, as the union of the dependencies of its subexpressions.
`boolean` | `createsNewNodes()` Determine whether this instruction creates new nodes.
`void` | `display(int level, PrintStream out, Configuration config)` Diagnostic print of expression structure.
`Item` | `evaluateSortKey(int n, XPathContext c)` Callback for evaluating the sort keys
`Expression` | `getActionExpression()` Get the action expression (the content of the for-each)
`Expression` | `getGroupingKey()` Get the grouping key expression expression (the group-by or group-adjacent expression, or a PatternSponsor containing the group-starting-with or group-ending-with expression)
`int` | `getInstructionNameCode()` Get the name of this instruction for diagnostic and tracing purposes
`ItemType` | `getItemType(TypeHierarchy th)` Get the item type of the items returned by evaluating this instruction
`SequenceIterator` | `iterate(XPathContext context)` Return an Iterator to iterate over the values of a sequence.
`Iterator` | `iterateSubExpressions()` Get all the XPath expressions associated with this instruction (in XSLT terms, the expression present on attributes of the instruction, as distinct from the child instructions in a sequence construction)
`SequenceIterator` | `map(XPathContext context)` Map one item to a sequence.
`Expression` | `optimize(Optimizer opt, StaticContext env, ItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`TailCall` | `processLeavingTail(XPathContext context)` ProcessLeavingTail: called to do the real work of this instruction.
`boolean` | `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
`Expression` | `simplify(StaticContext env)` Simplify an expression.
`Expression` | `typeCheck(StaticContext env, ItemType contextItemType)` Perform type checking of an expression and its subexpressions.

Methods inherited from class net.sf.saxon.instruct.Instruction
`appendItem, computeCardinality, computeSpecialProperties, evaluateAsString, evaluateItem, getImplementationMethod, getInstructionInfo, getSourceLocator, isXSLT, process, promote`

Methods inherited from class net.sf.saxon.expr.Expression
`adoptChildExpression, computeStaticProperties, doPromotion, effectiveBooleanValue, getCardinality, getColumnNumber, getContainingProcedure, getDependencies, getExecutable, getHostLanguage, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, markTailFunctionCalls, resetStaticProperties, setLocationId, setParentExpression, setParentExpression, suppressValidation`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface javax.xml.transform.SourceLocator
`getColumnNumber, getLineNumber, getPublicId, getSystemId`

Field Detail

### GROUP_BY

    public static final int GROUP_BY

See Also:
  Constant Field Values

### GROUP_ADJACENT

    public static final int GROUP_ADJACENT

See Also:
  Constant Field Values

### GROUP_STARTING

    public static final int GROUP_STARTING

See Also:
  Constant Field Values

### GROUP_ENDING

    public static final int GROUP_ENDING

See Also:
  Constant Field Values

Constructor Detail

### ForEachGroup

    public ForEachGroup(Expression select,
                        Expression action,
                        byte algorithm,
                        Expression key,
                        StringCollator collator,
                        Expression collationNameExpression,
                        String baseURI,
                        SortKeyDefinition[] sortKeys)

Method Detail

### getInstructionNameCode

    public int getInstructionNameCode()

  Get the name of this instruction for diagnostic and tracing purposes

  Overrides:
    `getInstructionNameCode` in class `Instruction`

### getActionExpression

    public Expression getActionExpression()

  Get the action expression (the content of the for-each)

### getGroupingKey

    public Expression getGroupingKey()

  Get the grouping key expression expression (the group-by or group-adjacent expression, or a PatternSponsor containing the group-starting-with or group-ending-with expression)

### simplify

    public Expression simplify(StaticContext env)
                        throws XPathException

  Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression).

  Specified by:
    `simplify` in class `Instruction`
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### typeCheck

    public Expression typeCheck(StaticContext env,
                                ItemType contextItemType)
                         throws XPathException

  Description copied from class: `Expression`
  Perform type checking of an expression and its subexpressions. This is the second phase of static optimization.

  This checks statically that the operands of the expression have the correct type; if necessary it generates code to do run-time type checking or type conversion. A static type error is reported only if execution cannot possibly succeed, that is, if a run-time type error is inevitable. The call may return a modified form of the expression.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable. However, the types of such functions and variables may not be accurately known if they have not been explicitly declared.

  If the implementation returns a value other than "this", then it is required to ensure that the parent pointer and location information in the returned expression have been set up correctly. It should not rely on the caller to do this, although for historical reasons many callers do so.

  Overrides:
    `typeCheck` in class `Expression`
  Parameters:
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `StaticError` - if an error is discovered during this phase (typically a type error)
    `XPathException`

### optimize

    public Expression optimize(Optimizer opt,
                               StaticContext env,
                               ItemType contextItemType)
                        throws XPathException

  Description copied from class: `Expression`
  Perform optimisation of an expression and its subexpressions. This is the third and final phase of static optimization.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `Expression`
  Parameters:
    `opt` - the optimizer in use. This provides access to supporting functions; it also allows different optimization strategies to be used in different circumstances.
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `StaticError` - if an error is discovered during this phase (typically a type error)
    `XPathException`

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Get the item type of the items returned by evaluating this instruction

  Overrides:
    `getItemType` in class `Instruction`
  Parameters:
    `th` -
  Returns:
    the static item type of the instruction

### computeDependencies

    public int computeDependencies()

  Compute the dependencies of an expression, as the union of the dependencies of its subexpressions. (This is overridden for path expressions and filter expressions, where the dependencies of a subexpression are not all propogated). This method should be called only once, to compute the dependencies; after that, getDependencies should be used.

  Overrides:
    `computeDependencies` in class `Expression`
  Returns:
    the depencies, as a bit-mask

### createsNewNodes

    public final boolean createsNewNodes()

  Determine whether this instruction creates new nodes. This implementation returns true if the "action" creates new nodes. (Nodes created by the condition can't contribute to the result).

  Overrides:
    `createsNewNodes` in class `Instruction`

### iterateSubExpressions

    public Iterator iterateSubExpressions()

  Get all the XPath expressions associated with this instruction (in XSLT terms, the expression present on attributes of the instruction, as distinct from the child instructions in a sequence construction)

  Overrides:
    `iterateSubExpressions` in class `Expression`
  Returns:
    an iterator containing the sub-expressions of this expression

### replaceSubExpression

    public boolean replaceSubExpression(Expression original,
                                        Expression replacement)

  Replace one subexpression by a replacement subexpression

  Specified by:
    `replaceSubExpression` in interface `Container`
  Overrides:
    `replaceSubExpression` in class `Expression`
  Parameters:
    `original` - the original subexpression
    `replacement` - the replacement subexpression
  Returns:
    true if the original subexpression is found

### checkPermittedContents

    public void checkPermittedContents(SchemaType parentType,
                                       StaticContext env,
                                       boolean whole)
                                throws XPathException

  Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.

  Overrides:
    `checkPermittedContents` in class `Expression`
  Throws:
    `XPathException`

### processLeavingTail

    public TailCall processLeavingTail(XPathContext context)
                                throws XPathException

  Description copied from class: `Instruction`
  ProcessLeavingTail: called to do the real work of this instruction. This method must be implemented in each subclass. The results of the instruction are written to the current Receiver, which can be obtained via the Controller.

  Specified by:
    `processLeavingTail` in interface `TailCallReturner`
  Specified by:
    `processLeavingTail` in class `Instruction`
  Parameters:
    `context` - The dynamic context of the transformation, giving access to the current node, the current variables, etc.
  Returns:
    null if the instruction has completed execution; or a TailCall indicating a function call or template call that is delegated to the caller, to be made after the stack has been unwound so as to save stack space.
  Throws:
    `XPathException`

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Return an Iterator to iterate over the values of a sequence. The value of every expression can be regarded as a sequence, so this method is supported for all expressions. This default implementation relies on the process() method: it "pushes" the results of the instruction to a sequence in memory, and then iterates over this in-memory sequence.

  In principle instructions should implement a pipelined iterate() method that avoids the overhead of intermediate storage.

  Specified by:
    `iterate` in interface `SequenceIterable`
  Overrides:
    `iterate` in class `Instruction`
  Parameters:
    `context` - supplies the context for evaluation
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### map

    public SequenceIterator map(XPathContext context)
                         throws XPathException

  Map one item to a sequence.

  Specified by:
    `map` in interface `ContextMappingFunction`
  Parameters:
    `context` - The processing context. This is supplied only for mapping constructs that set the context node, position, and size. Otherwise it is null.
  Returns:
    either (a) a SequenceIterator over the sequence of items that the supplied input item maps to, or (b) an Item if it maps to a single item, or (c) null if it maps to an empty sequence.
  Throws:
    `XPathException`

### evaluateSortKey

    public Item evaluateSortKey(int n,
                                XPathContext c)
                         throws XPathException

  Callback for evaluating the sort keys

  Specified by:
    `evaluateSortKey` in interface `SortKeyEvaluator`
  Throws:
    `XPathException`

### display

    public void display(int level,
                        PrintStream out,
                        Configuration config)

  Diagnostic print of expression structure. The expression is written to the System.err output stream

  Specified by:
    `display` in class `Expression`
  Parameters:
    `level` - indentation level for this expression
    `out` -
    `config` -

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.